/*
gcc -o windows_send_byte windows_send_byte.c -lwsock32 -Wall -DTEST_PRINTF
*/
#include  <WinSock2.h>
#include  <windows.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <time.h>

#define MAXLINE 1024


char *GetLastFileName(char *path)
{
    static char filename[256] = "";
    char* ptr = NULL;
    
    ptr = strrchr(path, '\\');     //ڿ(path) ڿ '\' ġ ˻Ͽ ȯ     
    if (ptr == NULL)
    {
        strcpy(filename, path);
    }
    else
    {
        strcpy(filename, ptr + 1); // Ϳ +1 Ͽ 
    }
    return filename;
}
int main(int argc, char *argv[])
{
	FILE *fp=NULL;
	char tmp[MAXLINE+3];
	char filename[MAXLINE];

	int kk, index = 0;
	int totalsize, totalsum = 0, readsize;

    WSADATA wsa;    //socket
	struct sockaddr_in server_addr;
    SOCKET clientsocket; //server connect socket

    if (argc != 4) 
    {
        printf("usage : %s server_address port filename\n", argv[0]);
        return(-1);
    }

    //socket initialization
    if (WSAStartup(MAKEWORD(2,2), &wsa) != 0) 
    {
        return(-2);
    }
    //socket creation
    if ((clientsocket = socket(AF_INET, SOCK_STREAM, 0)) < 0) 
    {
        printf("fail make socket\n");
        return(-3);
    }

    //memory initialization
    memset(&server_addr, 0x00, sizeof(server_addr));
    server_addr.sin_family = AF_INET;
    server_addr.sin_addr.s_addr = inet_addr(argv[1]);
    server_addr.sin_port = htons(atoi(argv[2]));

    //connection with server
    if (connect(clientsocket, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0) 
    {
        printf("fail connect to server\n");
        return(-4);
    }


    memset(filename, 0x00, sizeof(filename));
	strcpy(filename, GetLastFileName(argv[3]));

    if((fp = fopen(argv[3], "rb"))==NULL)
    {
        printf("fopen error(%s)[%s]\n", argv[3], filename);
        return(-5);
    }

	//  ũ⸦ ISize  Ѵ.
    fseek(fp, 0, SEEK_END);
    totalsize = ftell(fp);
    rewind(fp);


    //FILENAME SEND
	readsize = strlen(filename);

	filename[readsize+0]=0x0d;
	filename[readsize+1]=0x0e;
    filename[readsize+2]=0xff;

	if (send(clientsocket, filename, readsize+3, 0) < 0) 
    {
        return(-2);
    }
	printf("[%.5d][%.5d][%.*s]\n", index++, readsize, readsize, filename);
	

    readsize = MAXLINE;
	while(1) 
    {
        kk = fread(tmp, 1, readsize, fp);
		if(kk != readsize) break;

		totalsum += kk;

		tmp[readsize+0]=0x0d;
		tmp[readsize+1]=0x0e;
		tmp[readsize+2]=0xff;

        if (send(clientsocket, tmp, readsize+3, 0) < 0) 
        {
            return(-2);
        }

        if(totalsize == totalsum)
		{
			printf("[%.5d][%.5d][%.5d][%.5d][%.5d]\n", index++, readsize, totalsize, totalsum, kk);

			break;
		}
		else
		{
		    if(totalsize - totalsum < MAXLINE)
		    {
			    readsize = totalsize - totalsum;				
		    }

			printf("[%.5d][%.5d][%.5d][%.5d][%.5d]\n", index++, readsize, totalsize, totalsum, kk);
		}		

        Sleep(10);
    }
    closesocket(clientsocket);
    WSACleanup();

    if(fp != NULL) fclose(fp);
    return(0);
}
